#ifndef __TUYA_AI_MP3_PLAYER_H__
#define __TUYA_AI_MP3_PLAYER_H__

#include "tuya_cloud_types.h"

// play event: play, stop, pause, resume

typedef enum {
    TUYA_AI_PLAYER_STAT_IDLE = 0,
    TUYA_AI_PLAYER_STAT_PLAY,
    TUYA_AI_PLAYER_STAT_STOP,
    TUYA_AI_PLAYER_STAT_PAUSE,
    TUYA_AI_PLAYER_STAT_RESUME,
    TUYA_AI_PLAYER_STAT_DESTROY,
    TUYA_AI_PLAYER_STAT_ERROR,
    TUYA_AI_PLAYER_STAT_MAX,
} TUYA_AI_PLAYER_STAT;

typedef enum {
    TUYA_AI_ALART_TYPE_NORMAL = 0,
    TUYA_AI_ALART_TYPE_POWER_ON,             /* 开机上电播报 */
    TUYA_AI_ALART_TYPE_NOT_ACTIVE,           /* 还未配网 请先配网 */
    TUYA_AI_ALART_TYPE_NETWORK_CFG,          /* 进入配网状态，开始配网 */
    TUYA_AI_ALART_TYPE_NETWORK_CONNECTED,    /* 联网成功 */
    TUYA_AI_ALART_TYPE_NETWORK_FAIL,         /* 联网失败 重试 */
    TUYA_AI_ALART_TYPE_NETWORK_DISCONNECT,   /* 掉网 */
    TUYA_AI_ALART_TYPE_BATTERY_LOW,          /* 电量不足 */
    TUYA_AI_ALART_TYPE_PLEASE_AGAIN,         /* 请再说一遍 */
    TUYA_AI_ALART_TYPE_MAX,
} TUYA_AI_ALART_TYPE;

#define EVENT_T5_PLAYER "t5_player_evt"

OPERATE_RET tuya_ai_mp3_player_init(VOID);

INT_T tuya_ai_mp3_stream_write(CHAR_T *buf, UINT_T len);

INT_T tuya_ai_mp3_stream_read(CHAR_T *buf, UINT_T len);

INT_T tuya_ai_mp3_stream_get_size(VOID);

INT_T tuya_ai_mp3_stream_avail_size(VOID);

OPERATE_RET tuya_ai_mp3_stream_clear(VOID);

OPERATE_RET tuya_ai_mp3_player_play_raw(CHAR_T *data, UINT_T len);

OPERATE_RET tuya_ai_mp3_player_play_alert(TUYA_AI_ALART_TYPE type, BOOL_T send_eof);

OPERATE_RET tuya_ai_mp3_player_start(VOID);

OPERATE_RET tuya_ai_mp3_player_stop(VOID);

BOOL_T tuya_ai_mp3_is_playing(VOID);

OPERATE_RET tuya_ai_player_set_volume(INT_T vol);

INT_T tuya_ai_player_get_volume(VOID);

#endif /* __TUYA_AI_MP3_PLAYER_H__ */
